diff --git a/drivers/common/idpf/idpf_common_device.c b/drivers/common/idpf/idpf_common_device.c
index e8d69c2490..e67bd616dc 100644
--- a/drivers/common/idpf/idpf_common_device.c
+++ b/drivers/common/idpf/idpf_common_device.c
@@ -505,7 +505,7 @@ idpf_vport_deinit(struct idpf_vport *vport)
 	return 0;
 }
 int
-idpf_config_rss(struct idpf_vport *vport)
+idpf_vport_rss_config(struct idpf_vport *vport)
 {
 	int ret;
 
@@ -531,7 +531,7 @@ idpf_config_rss(struct idpf_vport *vport)
 }
 
 int
-idpf_config_irq_map(struct idpf_vport *vport, uint16_t nb_rx_queues)
+idpf_vport_irq_map_config(struct idpf_vport *vport, uint16_t nb_rx_queues)
 {
 	struct idpf_adapter *adapter = vport->adapter;
 	struct virtchnl2_queue_vector *qv_map;
@@ -606,7 +606,7 @@ idpf_config_irq_map(struct idpf_vport *vport, uint16_t nb_rx_queues)
 }
 
 int
-idpf_config_irq_unmap(struct idpf_vport *vport, uint16_t nb_rx_queues)
+idpf_vport_irq_unmap_config(struct idpf_vport *vport, uint16_t nb_rx_queues)
 {
 	idpf_vc_config_irq_map_unmap(vport, nb_rx_queues, false);
 
@@ -617,7 +617,7 @@ idpf_config_irq_unmap(struct idpf_vport *vport, uint16_t nb_rx_queues)
 }
 
 int
-idpf_create_vport_info_init(struct idpf_vport *vport,
+idpf_vport_info_init(struct idpf_vport *vport,
 			    struct virtchnl2_create_vport *vport_info)
 {
 	struct idpf_adapter *adapter = vport->adapter;
diff --git a/drivers/common/idpf/idpf_common_device.h b/drivers/common/idpf/idpf_common_device.h
index 583ca90361..545117df79 100644
--- a/drivers/common/idpf/idpf_common_device.h
+++ b/drivers/common/idpf/idpf_common_device.h
@@ -183,13 +183,13 @@ int idpf_vport_init(struct idpf_vport *vport,
 __rte_internal
 int idpf_vport_deinit(struct idpf_vport *vport);
 __rte_internal
-int idpf_config_rss(struct idpf_vport *vport);
+int idpf_vport_rss_config(struct idpf_vport *vport);
 __rte_internal
-int idpf_config_irq_map(struct idpf_vport *vport, uint16_t nb_rx_queues);
+int idpf_vport_irq_map_config(struct idpf_vport *vport, uint16_t nb_rx_queues);
 __rte_internal
-int idpf_config_irq_unmap(struct idpf_vport *vport, uint16_t nb_rx_queues);
+int idpf_vport_irq_unmap_config(struct idpf_vport *vport, uint16_t nb_rx_queues);
 __rte_internal
-int idpf_create_vport_info_init(struct idpf_vport *vport,
-				struct virtchnl2_create_vport *vport_info);
+int idpf_vport_info_init(struct idpf_vport *vport,
+			 struct virtchnl2_create_vport *vport_info);
 
 #endif /* _IDPF_COMMON_DEVICE_H_ */
diff --git a/drivers/common/idpf/version.map b/drivers/common/idpf/version.map
index a0e97de81f..bd4dae503a 100644
--- a/drivers/common/idpf/version.map
+++ b/drivers/common/idpf/version.map
@@ -3,14 +3,18 @@ INTERNAL {
 
 	idpf_adapter_deinit;
 	idpf_adapter_init;
+
+	idpf_vport_deinit;
+	idpf_vport_info_init;
+	idpf_vport_init;
+	idpf_vport_irq_map_config;
+	idpf_vport_irq_unmap_config;
+	idpf_vport_rss_config;
+
 	idpf_alloc_single_rxq_mbufs;
 	idpf_alloc_split_rxq_mbufs;
 	idpf_check_rx_thresh;
 	idpf_check_tx_thresh;
-	idpf_config_irq_map;
-	idpf_config_irq_unmap;
-	idpf_config_rss;
-	idpf_create_vport_info_init;
 	idpf_execute_vc_cmd;
 	idpf_prep_pkts;
 	idpf_register_ts_mbuf;
@@ -50,8 +54,6 @@ INTERNAL {
 	idpf_vc_set_rss_key;
 	idpf_vc_set_rss_lut;
 	idpf_vc_switch_queue;
-	idpf_vport_deinit;
-	idpf_vport_init;
 
 	local: *;
 };
diff --git a/drivers/net/idpf/idpf_ethdev.c b/drivers/net/idpf/idpf_ethdev.c
index ee2dec7c7c..b324c0dc83 100644
--- a/drivers/net/idpf/idpf_ethdev.c
+++ b/drivers/net/idpf/idpf_ethdev.c
@@ -169,7 +169,7 @@ idpf_init_rss(struct idpf_vport *vport)
 
 	vport->rss_hf = IDPF_DEFAULT_RSS_HASH_EXPANDED;
 
-	ret = idpf_config_rss(vport);
+	ret = idpf_vport_rss_config(vport);
 	if (ret != 0)
 		PMD_INIT_LOG(ERR, "Failed to configure RSS");
 
@@ -245,7 +245,7 @@ idpf_config_rx_queues_irqs(struct rte_eth_dev *dev)
 	struct idpf_vport *vport = dev->data->dev_private;
 	uint16_t nb_rx_queues = dev->data->nb_rx_queues;
 
-	return idpf_config_irq_map(vport, nb_rx_queues);
+	return idpf_vport_irq_map_config(vport, nb_rx_queues);
 }
 
 static int
@@ -334,7 +334,7 @@ idpf_dev_start(struct rte_eth_dev *dev)
 err_vport:
 	idpf_stop_queues(dev);
 err_startq:
-	idpf_config_irq_unmap(vport, dev->data->nb_rx_queues);
+	idpf_vport_irq_unmap_config(vport, dev->data->nb_rx_queues);
 err_irq:
 	idpf_vc_dealloc_vectors(vport);
 err_vec:
@@ -353,7 +353,7 @@ idpf_dev_stop(struct rte_eth_dev *dev)
 
 	idpf_stop_queues(dev);
 
-	idpf_config_irq_unmap(vport, dev->data->nb_rx_queues);
+	idpf_vport_irq_unmap_config(vport, dev->data->nb_rx_queues);
 
 	idpf_vc_dealloc_vectors(vport);
 
@@ -643,7 +643,7 @@ idpf_dev_vport_init(struct rte_eth_dev *dev, void *init_params)
 	vport->devarg_id = param->devarg_id;
 
 	memset(&create_vport_info, 0, sizeof(create_vport_info));
-	ret = idpf_create_vport_info_init(vport, &create_vport_info);
+	ret = idpf_vport_info_init(vport, &create_vport_info);
 	if (ret != 0) {
 		PMD_INIT_LOG(ERR, "Failed to init vport req_info.");
 		goto err;